100 REM PROGRAM TO ESTIMATE AN EXAMINEES ABILITY
110 REM UNDER A ONE,TWO,OR THREE-PARAMETER LOGISTIC ICC MODEL
120 DIM CPT(10),A(10),C(10),UIJ(10)
130 GOSUB 3000:REM READ CANNED DATA AND SET TRACES
140 IF(NPARA=1) THEN FOR I=1 TO 10:A(I)=1.0:NEXT I
150 THETA=0
160 GOSUB 2000:REM ESTIMATE ABILITY
170 PRINT "ESTIMATED ABILITY= ";THETA
180 STOP
REM ********END OF DRIVER SECTION
REM ********ABILITY ESTIMATION SUBROUTINE*******
2000 FOR NIT=1 TO MAXIT
2010 SUMNUM=0:SUMDEM=0:REM CLEAR SUMS
2020 PRINT:PRINT "ITERATION= ";NIT:PRINT "ITERATION= ";NIT
2030 FOR I=1 TO NITEM:REM ITEM LOOP
2040 REM CALCULATE PHAT
2050 DEV=CPT(I)+A(I)*THETA
2060 PHAT=1.0/(1.0+EXP(-DEV))
2070 IF(NPARA =3) GOTO 2210
2080 REM 1 AND 2 PARAMETER ICC MODELS
2090 WIJ=PHAT*(1.0-PHAT)
2100 VIJ=(UIJ(I)-PHAT)
2110 SUMNUM=SUMNUM+A(I)*VIJ
2120 SUMDEM=SUMDEM+A(I)^2*WIJ
2130 IF(TRALL=-1) THEN GOTO 2370
2140 PRINT TAB(10);"ITEM= ";I
2150 PRINT TAB(5);"INTERCEPT= ";CPT(I);TAB(30);"SLOPE= ";A(I);TAB(50);"THETA=";THETA
2160 PRINT TAB(5);"UIJ= ";UIJ(I);TAB(20);"DEV= ";DEV;TAB(35);"P HAT= ";PHAT
2170 PRINT TAB(5);"WIJ= ";WIJ;TAB(25);"VIJ= ";VIJ
2180 PRINT TAB(5);"NUMERATOR SUM= ";SUMNUM;TAB(40);"DENOMINATOR SUM = ";SUMDEM:PRINT
2190 GOTO 2370
2200 REM 3-PARAMETER ICC MODEL
2210 PT=C(I)+(1.0-C(I))*PHAT
2220 REM PROTECT AGAINST DIVIDE BY ZERO
2230 IF(PT < .00001) THEN PT=.00001
2240 IF(PT > .99999) THEN PT=.99999
2250 WIJ=PT*(1.0-PT)
2260 VIJ=(UIJ(I)-PT)
2270 PSP=PHAT/PT
2280 SUMNUM=SUMNUM+A(I)*VIJ*PSP
2290 SUMDEM=SUMDEM+A(I)^2*WIJ*PSP*PSP
2300 IF(TRALL=-1) THEN GOTO 2370
2310 PRINT TAB(10);"ITEM= ";I
2320 PRINT TAB(5);"C= ";C(I);TAB(15);"INTERCEPT= ";CPT(I);TAB(40);"SLOPE= ";A(I);TAB(60);"THETA=";THETA
2330 PRINT TAB(5);"UIJ= ";UIJ(I);TAB(20);"DEV= ";DEV
2340 PRINT TAB(5);"P HAT= ";PHAT;TAB(25);"PT= ";PT;TAB(45);"PSP= ";PSP
2350 PRINT TAB(5);"WIJ= ";WIJ;TAB(25);"VIJ= ";VIJ
2360 PRINT TAB(5);"NUMERATOR SUM= ";SUMNUM;TAB(40);"DENOMINATOR SUM = ";SUMDEM:PRINT
2370 NEXT I
2380 DELTA=SUMNUM/SUMDEM
2390 IF (TRALL=0)OR(TRMLE=0) THEN PRINT TAB(5);"CHANGE IN THETA= ";DELTA
2400 IF(ABS(DELTA)<BIGT) GOTO 2430
2410 REM PROTECT AGAINST BIG CHANGE IN THETA
2420 IF(DELTA > 0.0) THEN
     DELTA=BIGT
     ELSE
     DELTA= -BIGT
     END IF
2430 THETA=THETA+DELTA
2440 IF(TRALL=0) OR (TRMLE=0) THEN PRINT "THETA= ";THETA;TAB(20);"CHANGE = ";DELTA
2450 IF(ABS(DELTA) < .05) GOTO 2480
2460 NEXT NIT
2470 PRINT " REACHED MAX ITERATIONS"
2480 RETURN
REM *******READ CANNED DATA AND ESTABLISH TRACES*********
3000 NITEM=10:BIGT=.5
3010 FOR I=1 TO NITEM:READ UIJ(I):NEXT I
3020 FOR I=1 TO NITEM:READ CPT(I):NEXT I
3030 FOR I=1 TO NITEM:READ A(I):NEXT I
3040 FOR I=1 TO NITEM:READ C(I):NEXT I
3050 TRALL=-1:TRMLE=-1
3060 INPUT "TRACE ALL? Y/N ";YN$
3070 IF (YN$= "Y") THEN TRALL=0:TRMLE=0:GOTO 3100
3080 INPUT "TRACE MLE? Y/N ";YN$
3090 IF(YN$="Y") THEN TRMLE=0
3100 INPUT "ENTER NUMBER OF ITERATIONS TO DO ";MAXIT
3110 INPUT "ENTER NUMBER OF PARAMETERS IN ICC MODEL ";NPARA
3120 CLS:PRINT "ALL  MLE  MAX ITERATIONS  ICC MODEL"
3130 PRINT TAB(2);TRALL;TAB(6);TRMLE;TAB(14);MAXIT;TAB(28);NPARA
3140 RETURN
9500 DATA 1,1,1,0,0,0,1,0,1,1
9510 DATA .489,-.869,-1.247,.595,.126,.469,.058,.665,-1.292,-.490
9520 DATA .997,.874,1.100,1.435,1.351,1.501,1.955,.906,1.897,1.146
9530 DATA .15,.21,.23,.01,.21,.02,.27,.05,.31,.27


