100 REM PROGRAM TO IMPLMENT MARGINALIZED BAYESIAN ITEM PARAMETER ESTIMATION
105 REM USES B=DIFFICULTY,A=DISCRIMNATION, LSAT-6 DATA
110 DIM U(32,5),X(10),AK(10),FPT(32),LXK(32,10),PL(32)
120 DIM RIK(5,10),NK(5,10),PQ(10),A(5),B(5),PM(5),PV(5),ALPHA(5)
130 GOSUB 1500:REM READ CANNED DATA AND SET TRACES
140 FOR NC=1 TO MNC
150 PRINT " CYCLE=";NC:PRINT " CYCLE= ";NC
155 FOR L=1 TO 32:PL(L)=0:FOR K=1 TO 10:LXK(L,K)=1:NEXT K:NEXT L
160 REM E-STEP GET EXPECTED N AND R
170 GOSUB 300
180 REM M-STEP BAYES MODAL ESTIMATION OF ITEM PARAMETERS
190 FOR I=1 TO 5
200 GOSUB 1000
210 NEXT I
220 NEXT NC
230 REM DONE MAX CYCLES
240 PRINT "   ITEM";TAB(10);"DIFFICULTY";TAB(28);"DISCRIMINATION"
250 FOR I=1 TO 5
270 PRINT TAB(5);I;TAB(10);B(I);TAB(25);A(I)
280 NEXT I
290 STOP
REM **************END OF DRIVER SECTION*********
299 REM E-STEP SUBROUTINE
300 FOR L=1 TO 32
310 FOR K=1 TO 10
320 FOR I=1 TO 5
330 GOSUB 600
340 PQ(I)=P:IF U(L,I)=0 THEN PQ(I)=Q
342 IF TRALL<>0 GOTO 360
345 PRINT "345";TAB(5);L;TAB(10);K;TAB(15);I;TAB(20);PQ(I);TAB(40);U(L,I)
360 LXK(L,K)=LXK(L,K)*PQ(I)
370 NEXT I
375 IF (TRALL=0)OR(TRLP=0) THEN PRINT "L= ";L;TAB(10);"K= ";K;TAB(20);"L(X)= ";LXK(L,K)
380 NEXT K
390 PL(L)=0:FOR K=1 TO 10:PL(L)=PL(L)+LXK(L,K)*AK(K)
391 IF TRALL<>0 GOTO 395
392 PRINT "392";TAB(5);L;TAB(10);PL(L);TAB(35);LXK(L,K);TAB(50);AK(K)
395 NEXT K
398 IF (TRALL=0) OR(TRLP=0) THEN PRINT TAB(10);"P(";L;")= ";PL(L)
400 NEXT L
410 REM R BAR AND N BAR LOOP
420 FOR I=1 TO 5
425 IF (TRALL=0)OR(TRRN=0) THEN PRINT TAB(10);"ITEM ";I
430 FOR K=1 TO 10
435 RIK(I,K)=0:NK(I,K)=0
440 FOR L=1 TO 32:NT=FPT(L)*LXK(L,K)*AK(K)/PL(L):RT=NT*U(L,I):RIK(I,K)=RIK(I,K)+RT:NK(I,K)=NK(I,K)+NT
441 IF TRALL<>0 GOTO 448
442 PRINT "442";TAB(5);I;TAB(8);K;TAB(12);L;TAB(17);LXK(L,K);TAB(33);AK(K);TAB(50);PL(L)
444 PRINT "444";TAB(5);U(L,I);TAB(8);NT;TAB(24);RT;TAB(39);RT
446 PRINT "446";TAB(5);RIK(I,K);TAB(25);NK(I,K)
448 NEXT L
449 IF (TRALL=0)OR(TRRN=0) THEN PRINT "449";TAB(8);"X(";K;")= ";X(K);TAB(25);"RIK= ";RIK(I,K);TAB(43);"NK= ";NK(I,K)
450 NEXT K
460 NEXT I
470 RETURN
REM ******ROUTINE TO COMPUTE P(X)******
600 DEV=-A(I)*(X(K)-B(I))
610 P=1/(1+EXP(DEV)):Q=1-P
620 RETURN
999 REM M-STEP BAYESIAN MODAL ITEM PARAMETER ESTIMATION
1000 FOR NIT=1 TO 6
1030 ALPHA(I)=LOG(A(I))
1040 L1=0:L2=0:L11=0:L22=0:L12=0
1050 FOR K=1 TO 10:REM THETA LOOP
1060 NX=NK(I,K):IF NX=0 GOTO 1180
1070 IF TRALL<>0 GOTO 1140
1075 PRINT "M-STEP ITERATION= ";NIT;" ITEM= ";I;"  Q-NODE= ";K
1135 REM CALC P,Q
1140 GOSUB 600:REM B= THRESHOLD A=DISCRIMINATION
1142 W=P*(1-P):IF W<.0000009 GOTO 1180
1145 RMN=RIK(I,K)-NK(I,K)*P:W=P*(1-P):XMB=X(K)-B(I):IF TRALL<>0 GOTO 1160
1150 PRINT TAB(5);"P= ";P;"  W= ";W
1155 PRINT TAB(5);"R-N*P= ";RMN;"   X-B= ";XMB
1160 P1=NX*W:P2=P1*XMB:P3=P2*XMB:P4=RMN*XMB
1170 L1=L1+P4:L2=L2+RMN:L11=L11+P3:L22=L22+P1:L12=L12+P2
1171 IF TRALL<>0 GOTO 1180
1172 PRINT TAB(5);"P1= ";P1;"   P2= ";P2
1173 PRINT TAB(5);"P3= ";P3;"   P4= ";P4
1174 PRINT TAB(5);"L1= ";L1;"   L2= ";L2
1175 PRINT TAB(5);"L11= ";L11;"   L22= ";L22;"   L12=L21= ";L12
1180 NEXT K
1190 EA=EXP(ALPHA(I)):EA2=EA*EA
1192 IF FOFLG<>0 THEN LABAR=PM(I):GOTO 1195
1193 GOSUB 1400
1194 REM MULT BY EA AND ADD PRIOR TERMS
1195 L1=EA*L1-(ALPHA(I)-LABAR)/PV(I):L2=-EA*L2
1196 L11=EA2*L11+1/PV(I):L22=EA2*L22:L12=-EA2*L12
1197 REM -1 HAS BEEN INTRODUCED WHERE NEEDED IN THE EXPRESSIONS OF LINES 1195 AND 1196
1200 DM=L11*L22-L12*L12:IF TRALL<>0 GOTO 1230
1201 PRINT:PRINT TAB(5);"EA= ";EA;TAB(25);"EA2= ";EA2
1203 PRINT "AFTER MULTIPLYING BY LOG(A) AND ADDING BAYESIAN TERMS"
1205 PRINT TAB(5);"L1= ";L1;TAB(25);"L2= ";L2
1207 PRINT TAB(5);"L11= ";L11;"   L22= ";L22;;"   L12=L21= ";L12
1210 PRINT "DETERMINANT= ";DM
1230 IF DM<=.000099 GOTO 1350
1240 DA=(L1*L22-L2*L12)/DM
1250 DB=(-L1*L12+L2*L11)/DM
1270 ALPHA(I)=ALPHA(I)+DA:B(I)=B(I)+DB
1275 IF (TRALL=0) OR (TRBME=0) THEN
        PRINT "NIT= ";NIT;TAB(15);"ITEM= ";I
        PRINT "ALPHA(I)= ";ALPHA(I);TAB(26)"DA= ";DA
        PRINT "    B(I)= ";B(I);TAB(26);"DB= ";DB
     ELSE
     END IF
1290 IF(ABS(ALPHA(I))>30)OR(ABS(B(I))>20) GOTO 1350
1300 IF(ABS(DA)<=.05)AND(ABS(DB)<=.05) GOTO 1340
1330 NEXT NIT
1340 A(I)=EXP(ALPHA(I)):RETURN
1350 PRINT "OUT OF BOUNDS ERROR":GOTO 1340
REM ********ROUTINE TO GET MEAN OF LOG(A)**********
1400 SUMLA=0
1420 FOR IJ=1 TO 5:SUMLA=SUMLA+ALPHA(IJ):NEXT IJ
1430 LABAR=SUMLA/5
1440 RETURN
REM**********READ CANNED DATA AND SET TRACES*******
1500 FOR L=1 TO 32:FOR I=1 TO 5:READ U(L,I):NEXT I:NEXT L
1510 FOR K=1 TO 10:READ X(K):NEXT K
1520 FOR K=1 TO 10:READ AK(K):NEXT K
1530 FOR L=1 TO 32:READ FPT(L):NEXT L
1540 FOR I=1 TO 5:READ B(I),A(I):NEXT I
1550 FOR I=1 TO 5:READ PM(I),PV(I):PV(I)=PV(I)*PV(I):NEXT I
1560 REM SET UP TRACEING
1570 TRALL=-1:TRLP=-1:TRRN=-1:TRBME=-1
1580 INPUT "TRACE ALL? Y/N ";YN$
1590 IF (YN$="Y")OR(YN$="y") THEN TRALL=0:TRLP=0:TRRN=0:TRBME=0:GOTO 1660
1600 INPUT "TRACE L,P? Y/N ";YN$
1610 IF (YN$="Y")OR(YN$="y") THEN TRLP=0
1620 INPUT "TRACE R AND N? Y/N ";YN$
1630 IF (YN$="Y")OR(YN$="y") THEN TRRN=0
1640 INPUT "TRACE BME? Y/N ";YN$
1650 IF (YN$="Y")OR(YN$="y") THEN TRBME=0
1660 INPUT "USE FLOAT OPTION? Y/N ";YN$
1670 FOFLG=-1:IF (YN$="Y")OR(YN$="y") THEN FOFLG=0
1680 PRINT "FLOAT OPTION ";YN$
1690 INPUT "ENTER NUMBER OF CYCLES TO DO ";MNC
1700 PRINT " ALL  LP  RN  BME   MAX CYCLES"
1710 PRINT TAB(2);TRALL;TAB(6);TRLP;TAB(11);TRRN;TAB(15);TRBME;TAB(21);MNC
1720 CLS:RETURN
8999 REM ALL POSSIBLE ITEM RESPONSE PATTERNS
9000 DATA 0,0,0,0,0
9010 DATA 0,0,0,0,1
9020 DATA 0,0,0,1,0
9030 DATA 0,0,0,1,1
9040 DATA 0,0,1,0,0
9050 DATA 0,0,1,0,1
9060 DATA 0,0,1,1,0
9070 DATA 0,0,1,1,1
9080 DATA 0,1,0,0,0
9090 DATA 0,1,0,0,1
9100 DATA 0,1,0,1,0
9110 DATA 0,1,0,1,1
9120 DATA 0,1,1,0,0
9130 DATA 0,1,1,0,1
9140 DATA 0,1,1,1,0
9150 DATA 0,1,1,1,1
9160 DATA 1,0,0,0,0
9170 DATA 1,0,0,0,1
9180 DATA 1,0,0,1,0
9190 DATA 1,0,0,1,1
9200 DATA 1,0,1,0,0
9210 DATA 1,0,1,0,1
9220 DATA 1,0,1,1,0
9230 DATA 1,0,1,1,1
9240 DATA 1,1,0,0,0
9250 DATA 1,1,0,0,1
9260 DATA 1,1,0,1,0
9270 DATA 1,1,0,1,1
9280 DATA 1,1,1,0,0
9290 DATA 1,1,1,0,1
9300 DATA 1,1,1,1,0
9310 DATA 1,1,1,1,1
9400 REM QUADRATURE POINTS AND WEIGHTS VIA BILOG
9410 DATA -4.000,-3.111,-2.222,-1.333,-.4444,.4444,1.333,2.222
9420 DATA 3.111,4.000
9430 DATA .000119,.002805,.03002,.1458,.3213,.3213,.1458,.03002
9450 DATA .002805,.000119
9499 REM ITEM RESPONSE PATTERN FREQUENCIES
9500 DATA 3,6,2,11,1,1,3,4,1,8,0,16,0,3,2,15,10,29,14,81,3,28,15
9510 DATA 80,16,56,21,173,11,61,28,298
9599 REM INITIAL VALUES FOR B(I) AND A(I)
10000 DATA 0,1,0,1,0,1,0,1,0,1
10100 REM PRIOR MEAN AND STD DEVIATION ON LOG(A)
10110 DATA 0,.5,0,.5,0,.5,0,.5,0,.5

