      TRALL = -1
      INPUT "TRACE ALL? Y/N "; YN$
      IF (YN$ = "Y") OR (YN$ = "y") THEN TRALL = 0

      NG = 2
      NL = 16
      NI = 4
      NQ = 10

      DIM U(NG, NL, NI), Y(NG, NL, NI), X(NG, NQ), AX(NG, NQ)
      DIM SAX(NG), MU(NG), S2(NG), R(NG, NL)
      DIM LX(NG, NL, NQ), PB(NG, NL), ZETA(NI), LAMBDA(NI)
      DIM RB(NG, NI, NQ), NB(NG, NI, NQ)
      DIM XB(NG, NL), SN(NG), MUH(NG)
      DIM GOF(NG)

REM   Y=INDICATOR

      MNC = 25
      MIT = 10

      ZETA(1) = 0: ZETA(2) = 0: ZETA(3) = 0: ZETA(4) = 0
      LAMBDA(1) = 1: LAMBDA(2) = 1: LAMBDA(3) = 1: LAMBDA(4) = 1

      FOR G = 1 TO NG
        FOR L = 1 TO NL
          FOR I = 1 TO NI
            READ U(G, L, I)
          NEXT I
        NEXT L
      NEXT G
      DATA 0,0,0,0
      DATA 0,0,0,1
      DATA 1,0,0,0
      DATA 1,0,0,1
      DATA 0,1,0,0
      DATA 0,1,0,1
      DATA 0,0,1,0
      DATA 0,0,1,1
      DATA 1,1,0,0
      DATA 1,1,0,1
      DATA 1,0,1,0
      DATA 1,0,1,1
      DATA 0,1,1,0
      DATA 0,1,1,1
      DATA 1,1,1,0
      DATA 1,1,1,1
      DATA 0,0,0,0
      DATA 0,0,0,1
      DATA 1,0,0,0
      DATA 1,0,0,1
      DATA 0,1,0,0
      DATA 0,1,0,1
      DATA 0,0,1,0
      DATA 0,0,1,1
      DATA 1,1,0,0
      DATA 1,1,0,1
      DATA 1,0,1,0
      DATA 1,0,1,1
      DATA 0,1,1,0
      DATA 0,1,1,1
      DATA 1,1,1,0
      DATA 1,1,1,1

      FOR G = 1 TO NG
        FOR L = 1 TO NL
          FOR I = 1 TO NI
            READ Y(G, L, I)
          NEXT I
        NEXT L
      NEXT G
      DATA 1,1,1,1
      DATA 1,1,1,1
      DATA 1,1,1,1
      DATA 1,1,1,1
      DATA 1,1,1,1
      DATA 1,1,1,1
      DATA 1,1,1,1
      DATA 1,1,1,1
      DATA 1,1,1,1
      DATA 1,1,1,1
      DATA 1,1,1,1
      DATA 1,1,1,1
      DATA 1,1,1,1
      DATA 1,1,1,1
      DATA 1,1,1,1
      DATA 1,1,1,1
      DATA 1,1,1,1
      DATA 1,1,1,1
      DATA 1,1,1,1
      DATA 1,1,1,1
      DATA 1,1,1,1
      DATA 1,1,1,1
      DATA 1,1,1,1
      DATA 1,1,1,1
      DATA 1,1,1,1
      DATA 1,1,1,1
      DATA 1,1,1,1
      DATA 1,1,1,1
      DATA 1,1,1,1
      DATA 1,1,1,1
      DATA 1,1,1,1
      DATA 1,1,1,1
   
      FOR G = 1 TO NG
        FOR Q = 1 TO NQ
          READ X(G, Q)
        NEXT Q
      NEXT G
      DATA -4.5,-3.5,-2.5,-1.5,-0.5,0.5,1.5,2.5,3.5,4.5
      DATA -4.5,-3.5,-2.5,-1.5,-0.5,0.5,1.5,2.5,3.5,4.5

      MU(1) = 0
      S2(1) = 1
      MU(2) = 0
      S2(2) = 1

      FOR G = 1 TO NG
        FOR L = 1 TO NL
          READ R(G, L)
        NEXT L
      NEXT G
      DATA 29,7,50,30,15,4,6,0,67,63,12,10,2,6,22,51
      DATA 22,10,30,27,13,14,1,1,24,54,5,8,1,8,10,57

      NC = 1

100   PRINT: PRINT "CYCLE= "; NC

      SAX(1) = 0
      SAX(2) = 0
          
      FOR G = 1 TO NG
        FOR Q = 1 TO NQ
          PI = 3.141592654#
          AX(G,Q)=(1/(SQR(2*PI)))*EXP(-(1/2)*(X(G,Q)-MU(G))^2/S2(G))
          SAX(G) = SAX(G) + AX(G, Q)
        NEXT Q
      NEXT G

      FOR G = 1 TO NG
        FOR Q = 1 TO NQ
          AX(G, Q) = AX(G, Q) / SAX(G)
        NEXT Q
      NEXT G

      IF TRALL = 0 THEN
        PRINT
        PRINT "         G         Q    X(G,Q)   AX(G,Q)"
        FOR G = 1 TO NG
          FOR Q = 1 TO NQ
            PRINT USING "####.#####"; G; Q; X(G, Q); AX(G, Q)
          NEXT Q
        NEXT G
      END IF

      FOR G = 1 TO NG
        FOR L = 1 TO NL
          PB(G, L) = 0
          FOR Q = 1 TO NQ
            LX(G, L, Q) = 1
          NEXT Q
        NEXT L
      NEXT G

REM   E STAGE

      IF TRALL = 0 THEN
        PRINT
        PRINT "         G         I         K      P(I)"
      END IF
      FOR G = 1 TO NG
        FOR L = 1 TO NL
          FOR I = 1 TO NI
            FOR Q = 1 TO NQ
              IF Y(G, L, I) = 0 GOTO 230
              PQ = 1 / (1 + EXP(-(ZETA(I) + LAMBDA(I) * X(G, Q))))
              IF (L = 1) AND (TRALL = 0) THEN
                PRINT USING "####.#####"; G; I; Q; PQ
              END IF
              IF U(G, L, I) = 0 THEN PQ = 1 - PQ
              LX(G, L, Q) = LX(G, L, Q) * PQ
230         NEXT Q
          NEXT I
          PB(G, L) = 0
          FOR Q = 1 TO NQ
            PB(G, L) = PB(G, L) + LX(G, L, Q) * AX(G, Q)
          NEXT Q
        NEXT L
      NEXT G
     
      IF TRALL = 0 THEN
        PRINT
        PRINT "         G         L   PB(G,L)"
        FOR G = 1 TO NG
          FOR L = 1 TO NL
            PRINT USING "####.#####"; G; L; PB(G, L)
          NEXT L
        NEXT G
      END IF

      IF TRALL = 0 THEN
        PRINT
        PRINT "         G         L         Q LX(G,L,Q)"
        FOR G = 1 TO NG
          FOR L = 1 TO NL
            FOR Q = 1 TO NQ
              PRINT USING "####.#####"; G; L; Q; LX(G, L, Q)
            NEXT Q
          NEXT L
        NEXT G
      END IF

REM   N BAR AND R BAR
     
      FOR G = 1 TO NG
        FOR I = 1 TO NI
          FOR Q = 1 TO NQ
            RB(G, I, Q) = 0
            NB(G, I, Q) = 0
            FOR L = 1 TO NL
              IF Y(G, L, I) = 0 GOTO 320
              RB(G,I,Q)=RB(G,I,Q)+U(G,L,I)*R(G,L)*LX(G,L,Q)*AX(G,Q)/PB(G,L)
              NB(G,I,Q)=NB(G,I,Q)+R(G,L)*LX(G,L,Q)*AX(G,Q)/PB(G,L)
320         NEXT L
          NEXT Q
        NEXT I
      NEXT G
     
      IF TRALL = 0 THEN
        FOR G = 1 TO NG
          FOR I = 1 TO NI
            PRINT
            PRINT "         G         I         Q RB(G,I,Q) NB(G,I,Q)"
            FOR Q = 1 TO NQ
              PRINT USING "####.#####"; G; I; Q; RB(G, I, Q); NB(G, I, Q)
            NEXT Q
          NEXT I
        NEXT G
      END IF
     
REM   PROBIT STAGE M-STEP
     
      FOR I = 1 TO NI

      IF TRALL = 0 THEN
        PRINT
        PRINT "         I        IT   ZETA(I) LAMBDA(I)"
      END IF

      FOR IT = 1 TO MIT
        SSZ = 0
        SSL = 0
        SSZZ = 0
        SSZL = 0
        SSLL = 0
        FOR G = 1 TO NG
          FOR Q = 1 TO NQ
            IF NB(G, I, Q) <> 0 THEN
              PX = 1 / (1 + EXP(-(ZETA(I) + LAMBDA(I) * X(G, Q))))
              W = PX * (1 - PX)
              SSZ = SSZ + RB(G, I, Q) - NB(G, I, Q) * PX
              SSL = SSL + (RB(G, I, Q) - NB(G, I, Q) * PX) * X(G, Q)
              SSZZ = SSZZ - NB(G, I, Q) * W
              SSZL = SSZL - NB(G, I, Q) * W * X(G, Q)
              SSLL = SSLL - NB(G, I, Q) * W * X(G, Q) ^ 2
          END IF
        NEXT Q
      NEXT G
      DET = SSZZ * SSLL - SSZL ^ 2
      DZETA = (SSLL * SSZ - SSZL * SSL) / DET
      DLAMBDA = (-SSZL * SSZ + SSZZ * SSL) / DET
      ZETA(I) = ZETA(I) - DZETA
      LAMBDA(I) = LAMBDA(I) - DLAMBDA
      IF TRALL = 0 THEN
        PRINT USING "####.#####"; I; IT; ZETA(I); LAMBDA(I)
      END IF
      IF (ABS(DZETA) <= .01) AND (ABS(DLAMBDA) <= .01) GOTO 400
        NEXT IT
400   NEXT I
     
      PRINT
      PRINT "         I   ZETA(I) LAMBDA(I)      B(I)"
      FOR I = 1 TO NI
        PRINT USING "####.#####"; I; ZETA(I); LAMBDA(I); -ZETA(I) / LAMBDA(I)
      NEXT I

      FOR G = 1 TO NG
        SN(G) = 0
        FOR L = 1 TO NL
           SN(G) = SN(G) + R(G, L)
        NEXT L
      NEXT G
   
REM   ESTIMATE MUH(1) ONLY

      MUH(1) = 0
      FOR L = 1 TO NL
        XB(1, L) = 0
        FOR Q = 1 TO NQ
          XB(1, L) = XB(1, L) + X(1, Q) * LX(1, L, Q) * AX(1, Q)
        NEXT Q
        XB(1, L) = XB(1, L) / PB(1, L)
        MUH(1) = MUH(1) + R(1, L) * XB(1, L)
      NEXT L

      MUH(1) = (1 / SN(1)) * MUH(1)
      PRINT
      PRINT "    MUH(1)"
      PRINT USING "####.#####"; MUH(1)
      PRINT
      PRINT "      N(1)"
      PRINT USING "####.#####"; SN(1)
      MU(1) = MUH(1)

REM   ABOVE=DO NOT UPDATE

      NC = NC + 1
      IF NC <= MNC GOTO 100

REM   LIKELIHOOD-RATIO GOODNESS-OF-FIT STATISTIC

      FOR G = 1 TO NG
        FOR L = 1 TO NL
          FOR Q = 1 TO NQ
            LX(G, L, Q) = 1
          NEXT Q
        NEXT L
      NEXT G

      FOR G = 1 TO NG
        FOR L = 1 TO NL
          FOR I = 1 TO NI
            FOR Q = 1 TO NQ
              IF Y(G, L, I) = 0 GOTO 540
              PQ = 1 / (1 + EXP(-(ZETA(I) + LAMBDA(I) * X(G, Q))))
              IF U(G, L, I) = 0 THEN PQ = 1 - PQ
              LX(G, L, Q) = LX(G, L, Q) * PQ
540         NEXT Q
          NEXT I
          PB(G, L) = 0
          FOR Q = 1 TO NQ
            PB(G, L) = PB(G, L) + LX(G, L, Q) * AX(G, Q)
          NEXT Q
        NEXT L
      NEXT G

      FOR G = 1 TO NG
        PRINT
        PRINT "         G         L    R(G,L)     SN(G)   PB(G,L)     SN*PB"
        FOR L = 1 TO NL
          PRINT USING "####.#####";G;L;R(G,L);SN(G);PB(G,L);SN(G)*PB(G, L)
        NEXT L
      NEXT G

      GOF(1) = 0
      GOF(2) = 0
      FOR G = 1 TO NG
        FOR L = 1 TO NL
          IF R(G, L) = 0 GOTO 560
          GOF(G) = GOF(G) + 2 * R(G, L) * LOG(R(G, L) / (SN(G) * PB(G, L)))
560     NEXT L
      NEXT G

      PRINT
      PRINT "         G    GOF(G)"
      FOR G = 1 TO NG
        PRINT USING "####.#####"; G; GOF(G)
      NEXT G

      LRGOF = 0
      FOR G = 1 TO NG
        LRGOF = LRGOF + GOF(G)
      NEXT G
     
      PRINT
      PRINT "LIKELIHOOD-RATIO GOODNESS-OF-FIT=  "; USING "####.#####"; LRGOF

      END

