DECLARE FUNCTION RANDN! (IDUM&)
DECLARE FUNCTION RAND! (IDUM&)
DECLARE FUNCTION PHIINV (P!)
DECLARE FUNCTION PHI (X!)
DIM TITLE AS STRING * 64
DIM A(50), G(50), TH(100), Y(50, 100), Z(50, 100)
DIM XPX(2, 2), XPXINV(2, 2), AMAT(2, 2), AMATT(2, 2)
DIM PP(2, 2)
OPEN "GIBBS.LOG" FOR OUTPUT AS #9
INPUT "ENTER TITLE FOR RUN= "; TITLE
PRINT #9, TITLE
INPUT "ENTER NUMBER OF EXAMINEES= "; NEXAM
NEXAM$ = "NUMBER OF EXAMINEES= "
PRINT #9, NEXAM$, NEXAM
INPUT "ENTER NUMBER OF ITEMS= "; NITEM
NITEM$ = "NUMBER OF ITEMS= "
PRINT #9, NITEM$, NITEM
OPEN "IRPB.DAT" FOR INPUT AS #10
FOR J = 1 TO NEXAM
  FOR I = 1 TO NITEM
    INPUT #10, Y(I, J)
  NEXT I
NEXT J
CLOSE #10
INPUT "ENTER SEED FOR RN GENERATORS USE 6 DIGITS= "; IDUM&
IDUM$ = "RN SEED USED WAS= "
PRINT #9, IDUM$, IDUM&
ISEED& = -IDUM&
TRN = RAND(ISEED&)
FMU = 0!
VAR = 1!
FOR I = 1 TO NITEM
  PMA = 1!
  A(I) = PMA
NEXT I
FOR I = 1 TO NITEM
  SUM1 = 0!
  FOR J = 1 TO NEXAM
    SUM1 = SUM1 + Y(I, J)
  NEXT J
  PHAT = (SUM1 + .5) / (CSNG(NEXAM) + 1!)
  G(I) = -PHIINV(PHAT) * SQR(1! + PMA)
NEXT I
FOR J = 1 TO NEXAM
  TH(J) = 0!
NEXT J
INPUT "ENTER ITERATION NUMBER TO START RECORDING= "; ITO
ITO$ = "ITERATION NUMBER TO START RECORDING= "
PRINT #9, ITO$, ITO
INPUT "ENTER NUMBER OF ITERATES BETWEEN RECORDINGS= "; IWO
IWO$ = "NUMBER OF ITERATES BETWEEN RECORDINGS (T)= "
PRINT #9, IWO$, IWO
INPUT "ENTER NUMBER OF RECORDED ITERATES= "; NUM
NUM$ = "NUMBER OF RECORDED ITERATES (NUM)= "
PRINT #9, NUM$, NUM
CLOSE #9
ITOTAL = ITO + (NUM - 1) * IWO
OPEN "ITEM.OUT" FOR OUTPUT AS #11
OPEN "THET.OUT" FOR OUTPUT AS #12
OPEN "AVECT.COL" FOR OUTPUT AS #13
OPEN "GVECT.COL" FOR OUTPUT AS #14
IDIFF = IWO - 1
FOR KK = 1 TO ITOTAL
  PRINT "ITERATION= "; KK
  FOR I = 1 TO NITEM
    FOR J = 1 TO NEXAM
      FLP = TH(J) * A(I) - G(I)
      BB = PHI(-FLP)
      U = RAND(IDUM&)
      TT = (BB * (1! - Y(I, J)) + (1! - BB) * Y(I, J)) * U + _
        BB * Y(I, J)
      Z(I, J) = PHIINV(TT) + FLP
    NEXT J
  NEXT I
  SUMA2 = 0!
  FOR I = 1 TO NITEM
    SUMA2 = SUMA2 + A(I) * A(I)
  NEXT I
  V = 1! / SUMA2
  PVAR = 1! / (1! / V + 1! / VAR)
  FOR J = 1 TO NEXAM
    FMN = 0!
    FOR I = 1 TO NITEM
      FMN = FMN + (A(I) * (Z(I, J) + G(I)))
    NEXT I
    PMEAN = (FMN + FMU / VAR) * PVAR
    TH(J) = RANDN(IDUM&) * SQR(PVAR) + PMEAN
  NEXT J
  XPX(1, 1) = 0!
  XPX(1, 2) = 0!
  XPX(2, 1) = 0!
  XPX(2, 2) = CSNG(NEXAM)
  FOR J = 1 TO NEXAM
    XPX(1, 1) = XPX(1, 1) + TH(J) * TH(J)
    XPX(1, 2) = XPX(1, 2) + TH(J)
  NEXT J
  XPX(1, 2) = -XPX(1, 2)
  XPX(2, 1) = XPX(1, 2)
  SDA = .5
  SDG = 2!
  PP(1, 1) = 1! / (SDA ^ 2)
  PP(1, 2) = 0!
  PP(2, 1) = 0!
  PP(2, 2) = 1! / (SDG ^ 2)
  XPX(1, 1) = XPX(1, 1) + PP(1, 1)
  XPX(1, 2) = XPX(1, 2) + PP(1, 2)
  XPX(2, 1) = XPX(2, 1) + PP(2, 1)
  XPX(2, 2) = XPX(2, 2) + PP(2, 2)
  DET = (XPX(1, 1) * XPX(2, 2) - XPX(1, 2) * XPX(2, 1))
  XPXINV(1, 1) = XPX(2, 2) / DET
  XPXINV(1, 2) = -XPX(1, 2) / DET
  XPXINV(2, 1) = -XPX(2, 1) / DET
  XPXINV(2, 2) = XPX(1, 1) / DET
  AMAT(1, 1) = SQR(XPXINV(1, 1))
  AMAT(1, 2) = XPXINV(1, 2) / AMAT(1, 1)
  AMAT(2, 1) = 0!
  AMAT(2, 2) = SQR(XPXINV(2, 2) - _
    (XPXINV(1, 2) * XPXINV(1, 2) / XPXINV(1, 1)))
  FOR I = 1 TO NITEM
    XPZ1 = 0!
    XPZ2 = 0!
    FOR J = 1 TO NEXAM
      XPZ1 = XPZ1 + TH(J) * Z(I, J)
      XPZ2 = XPZ2 + Z(I, J)
    NEXT J
    XPZ2 = -XPZ2
    PMA = 1!
    PMB = 0!
    BZ1 = XPXINV(1, 1) * (XPZ1 + PP(1, 1) * PMA) + _
      XPXINV(1, 2) * (XPZ2 + PP(2, 2) * PMB)
    BZ2 = XPXINV(2, 1) * (XPZ1 + PP(1, 1) * PMA) + _
      XPXINV(2, 2) * (XPZ2 + PP(2, 2) * PMB)
    AMATT(1, 1) = AMAT(1, 1)
    AMATT(1, 2) = AMAT(2, 1)
    AMATT(2, 1) = AMAT(1, 2)
    AMATT(2, 2) = AMAT(2, 2)
    DO
      RN1 = RANDN(IDUM&)
      RN2 = RANDN(IDUM&)
      A(I) = AMATT(1, 1) * RN1 + AMATT(1, 2) * RN2 + BZ1
      G(I) = AMATT(2, 1) * RN1 + AMATT(2, 2) * RN2 + BZ2
    LOOP UNTIL A(I) > 0.
  NEXT I
  IF KK >= ITO THEN
    IDIFF = IDIFF + 1
    IF IDIFF = IWO THEN
      IDIFF = 0
      FOR I = 1 TO NITEM
        PRINT #11, USING "####.#####"; KK; I; A(I); G(I)
      NEXT I
      FOR J = 1 TO NEXAM
        PRINT #12, USING "####.#####"; KK; J; TH(J)
      NEXT J
      FOR I = 1 TO NITEM
        PRINT #13, USING "####.#####"; A(I)
      NEXT I
      FOR I = 1 TO NITEM
        PRINT #14, USING "####.#####"; G(I)
      NEXT I
    END IF
  END IF
NEXT KK
CLOSE #12
CLOSE #11
END

FUNCTION PHI (X)
' (ABRAMOWITZ & STEGUN, 1972, P. 932)
IF X < -4.87726 THEN
  PHI = .00001
ELSEIF X > 4.87726 THEN
  PHI = .99999
ELSE
  Y = 0!
  IF X < 0! THEN
    Y = -1!
    X = -X
  END IF
  D1 = .049867347#
  D2 = .0211410061#
  D3 = .0032776263#
  D4 = .0000380036#
  D5 = .0000488906#
  D6 = .000005383#
  PHI = 1! - (1! / 2!) / (1! + D1 * X + D2 * X ^ 2 + _
    D3 * X ^ 3 + D4 * X ^ 4 + D5 * X ^ 5 + D6 * X ^ 6) ^ 16
  IF Y = -1! THEN
    PHI = (1! / 2!) / (1! + D1 * X + D2 * X ^ 2 + _
      D3 * X ^ 3 + D4 * X ^ 4 + D5 * X ^ 5 + D6 * X ^ 6) ^ 16
    X = -X
  END IF
END IF
END FUNCTION

FUNCTION PHIINV (P)
' (ABRAMOWITZ & STEGUN, 1972, P. 933)
IF P < .00001 THEN
  PHIINV = -4.87762
ELSEIF P > .99999 THEN
  PHIINV = 4.87762
ELSE
  Y = 0!
  IF P > .5 THEN
    Y = -1!
    P = 1 - P
  END IF
  T = SQR(LOG(1 / P ^ 2))
  C0 = 2.515517
  C1 = .802853
  C2 = .010328
  D1 = 1.432788
  D2 = .189269
  D3 = .001308
  PHIINV = -T + (C0 + C1 * T + C2 * T ^ 2) / _
    (1! + D1 * T + D2 * T ^ 2 + D3 * T ^ 3)
  IF Y = -1! THEN
    PHIINV = T - (C0 + C1 * T + C2 * T ^ 2) / _
      (1! + D1 * T + D2 * T ^ 2 + D3 * T ^ 3)
    P = 1 - P
  END IF
END IF
END FUNCTION

FUNCTION RAND (IDUM&) STATIC
' (CF. SPROTT, 1991, PP. 139-140; PRESS ET AL., 1992, P. 271)
IA& = 16807
IM& = 2147483647
AM = 4.65661287D-10
IQ& = 127773
IR& = 2836
NTAB& = 32
NDIV& = 67108865
EPS = .00000012#
RNMX = .99999988#
DIM IV&(32)
STATIC IV&, IY&
IF IDUM& <= 0 OR IY& = 0 THEN
  IDUM& = 1
  IF -IDUM& > 1 THEN IDUM& = -IDUM&
  FOR J = NTAB& + 8 TO 1 STEP -1
    K& = IDUM& / IQ&
    IDUM& = IA& * (IDUM& - K& * IQ&) - IR& * K&
    IF IDUM& < 0 THEN IDUM& = IDUM& + IM&
    IF J <= NTAB& THEN IV&(J) = IDUM&
  NEXT J
  IY& = IV&(1)
END IF
K& = IDUM& / IQ&
IDUM& = IA& * (IDUM& - K& * IQ&) - IR& * K&
IF IDUM& < 0 THEN IDUM& = IDUM& + IM&
J = 1 + IY& / NDIV&
IF J < 1 THEN J = 1
IF J > 32 THEN J = 32
IY& = IV&(J)
IV&(J) = IDUM&
RAND = AM * IY&
IF AM * IY& > RNMX THEN RAND = RNMX
END FUNCTION

FUNCTION RANDN (IDUM&)
' (CF. SPROTT, 1991, P. 145)
STATIC ISET, GSET
IF ISET = 0 THEN
  DO
    V1 = 2! * RAND(IDUM&) - 1!
    V2 = 2! * RAND(IDUM&) - 1!
    RSQ = V1 ^ 2 + V2 ^ 2
  LOOP UNTIL RSQ < 1! AND RSQ <> 0!
  FAC = SQR(-2! * LOG(RSQ) / RSQ)
  GSET = V1 * FAC
  RANDN = V2 * FAC
  ISET = 1
ELSE
  RANDN = GSET
  ISET = 0
END IF
END FUNCTION

