postscript("fig1-2.eps",width=3.5,height=2.5,pointsize=7)
par(mfrow=c(1,1),lab=c(8,3,3))
theta<-seq(-3,3,.1)
z<-1*(theta-.5)
p<-pnorm(z,0,1)
plot(theta,p,type="l",xlim=c(-3,3),ylim=c(0,1),
xlab="Ability",ylab="Probability of Correct/Incorrect Response",bty="l")
par(new=T)
q<-1-p
plot(theta,q,type="l",xlim=c(-3,3),ylim=c(0,1),
xlab="",ylab="",bty="l")
text(-2.60,0.9,"Incorrect")
text( 2.60,0.9,"Correct")
dev.off()
dos("copy fig1-2.eps lpt1")
