postscript("fig1-3.eps",width=3.5,height=3.5,pointsize=7)
par(mfrow=c(1,1),lab=c(8,8,3))
theta<-seq(-2.1,2.1,.1)
g0<-2.5*dnorm(theta,0,1)-.05
g00<-0*theta
plot(g0,theta,type="l",xlim=c(-3,3),ylim=c(-3,3),
xlab="Ability",ylab="Item Variable",bty="l")
par(new=T)
plot(g00,theta,type="l",xlim=c(-3,3),ylim=c(-3,3),
xlab="",ylab="",bty="l")
theta2<-theta+1
g2<-g0+2
g22<-g00+2
par(new=T)
plot(g2,theta2,type="l",xlim=c(-3,3),ylim=c(-3,3),
xlab="",ylab="",bty="l")
par(new=T)
plot(g22,theta2,type="l",xlim=c(-3,3),ylim=c(-3,3),
xlab="",ylab="",bty="l")
theta1<-theta-1
g1<-g0-2
g11<-g00-2
par(new=T)
plot(g1,theta1,type="l",xlim=c(-3,3),ylim=c(-3,3),
xlab="",ylab="",bty="l")
par(new=T)
plot(g11,theta1,type="l",xlim=c(-3,3),ylim=c(-3,3),
xlab="",ylab="",bty="l")
t<-seq(-3.1,3.1,.1)
gl<-.5*t
l1<-0*t+1
l0<-0*t
l2<-0*t-1
par(new=T)
plot(t,gl,type="l",xlim=c(-3,3),ylim=c(-3,3),
xlab="",ylab="",bty="l")
par(new=T)
plot(t,l0,type="l",xlim=c(-3,3),ylim=c(-3,3),
xlab="",ylab="",bty="l")
text(-1.60,1.0,"P (0)")
text(-1.67,0.9,"i",cex=.7)
text(-1.50,1.03,"-",cex=.7)
text( 0.40,2.0,"P (0)")
text( 0.33,1.9,"i",cex=.7)
text( 0.50,2.03,"-",cex=.7)
text( 2.40,3.0,"P (0)")
text( 2.33,2.9,"i",cex=.7)
text( 2.50,3.03,"-",cex=.7)
text(-2.65,0.75,"u =1")
text(-2.72,0.65,"i",cex=.7)
text(-2.65,-0.65,"u =0")
text(-2.72,-0.75,"i",cex=.7)
text(-2.8,0.2,"threshold",cex=.7)
text(-2.6,-1.7,"regression line",cex=.7)
text(-1.96,1.00,"-")
text(-1.95,0.90,"-")
text(-1.95,0.80,"-")
text(-1.95,0.70,"-")
text(-1.95,0.60,"-")
text(-1.95,0.50,"-")
text(-1.95,0.40,"-")
text(-1.95,0.30,"-")
text(-1.95,0.20,"-")
text(-1.95,0.10,"-")
text(-1.90,0.80,"-")
text(-1.85,0.70,"-")
text(-1.85,0.60,"-")
text(-1.85,0.50,"-")
text(-1.85,0.40,"-")
text(-1.85,0.30,"-")
text(-1.85,0.20,"-")
text(-1.85,0.10,"-")
text(-1.80,0.50,"-")
text(-1.75,0.40,"-")
text(-1.75,0.30,"-")
text(-1.75,0.20,"-")
text(-1.75,0.10,"-")
text(-1.70,0.30,"-")
text(-1.65,0.20,"-")
text(-1.65,0.10,"-")
text(-1.55,0.10,"-")
text(0.05,2.00,"-")
text(0.05,1.90,"-")
text(0.05,1.80,"-")
text(0.05,1.70,"-")
text(0.05,1.60,"-")
text(0.05,1.50,"-")
text(0.05,1.40,"-")
text(0.05,1.30,"-")
text(0.05,1.20,"-")
text(0.05,1.10,"-")
text(0.05,1.00,"-")
text(0.05,0.90,"-")
text(0.05,0.80,"-")
text(0.05,0.70,"-")
text(0.05,0.60,"-")
text(0.05,0.50,"-")
text(0.05,0.40,"-")
text(0.05,0.30,"-")
text(0.05,0.20,"-")
text(0.05,0.10,"-")
text(0.06,1.80,"-")
text(0.15,1.70,"-")
text(0.15,1.60,"-")
text(0.15,1.50,"-")
text(0.15,1.40,"-")
text(0.15,1.30,"-")
text(0.15,1.20,"-")
text(0.15,1.10,"-")
text(0.15,1.00,"-")
text(0.15,0.90,"-")
text(0.15,0.80,"-")
text(0.15,0.70,"-")
text(0.15,0.60,"-")
text(0.15,0.50,"-")
text(0.15,0.40,"-")
text(0.15,0.30,"-")
text(0.15,0.20,"-")
text(0.15,0.10,"-")
text(0.25,1.50,"-")
text(0.25,1.40,"-")
text(0.25,1.30,"-")
text(0.25,1.20,"-")
text(0.25,1.10,"-")
text(0.25,1.00,"-")
text(0.25,0.90,"-")
text(0.25,0.80,"-")
text(0.25,0.70,"-")
text(0.25,0.60,"-")
text(0.25,0.50,"-")
text(0.25,0.40,"-")
text(0.25,0.30,"-")
text(0.25,0.20,"-")
text(0.25,0.10,"-")
text(0.35,1.30,"-")
text(0.35,1.20,"-")
text(0.35,1.10,"-")
text(0.35,1.00,"-")
text(0.35,0.90,"-")
text(0.35,0.80,"-")
text(0.35,0.70,"-")
text(0.35,0.60,"-")
text(0.35,0.50,"-")
text(0.35,0.40,"-")
text(0.35,0.30,"-")
text(0.35,0.20,"-")
text(0.35,0.10,"-")
text(0.45,1.10,"-")
text(0.45,1.00,"-")
text(0.45,0.90,"-")
text(0.45,0.80,"-")
text(0.45,0.70,"-")
text(0.45,0.60,"-")
text(0.45,0.50,"-")
text(0.45,0.40,"-")
text(0.45,0.30,"-")
text(0.45,0.20,"-")
text(0.45,0.10,"-")
text(0.50,1.00,"-")
text(0.55,0.90,"-")
text(0.55,0.80,"-")
text(0.55,0.70,"-")
text(0.55,0.60,"-")
text(0.55,0.50,"-")
text(0.55,0.40,"-")
text(0.55,0.30,"-")
text(0.55,0.20,"-")
text(0.55,0.10,"-")
text(0.60,0.80,"-")
text(0.65,0.70,"-")
text(0.65,0.60,"-")
text(0.65,0.50,"-")
text(0.65,0.40,"-")
text(0.65,0.30,"-")
text(0.65,0.20,"-")
text(0.65,0.10,"-")
text(0.75,0.60,"-")
text(0.75,0.50,"-")
text(0.75,0.40,"-")
text(0.75,0.30,"-")
text(0.75,0.20,"-")
text(0.75,0.10,"-")
text(0.80,0.40,"-")
text(0.85,0.30,"-")
text(0.85,0.20,"-")
text(0.85,0.10,"-")
text(0.86,0.10,"_")
text(2.05,3.00,"-")
text(2.05,2.90,"-")
text(2.05,2.80,"-")
text(2.05,2.70,"-")
text(2.05,2.60,"-")
text(2.05,2.50,"-")
text(2.05,2.40,"-")
text(2.05,2.30,"-")
text(2.05,2.20,"-")
text(2.05,2.10,"-")
text(2.05,2.00,"-")
text(2.05,1.90,"-")
text(2.05,1.80,"-")
text(2.05,1.70,"-")
text(2.05,1.60,"-")
text(2.05,1.50,"-")
text(2.05,1.40,"-")
text(2.05,1.30,"-")
text(2.05,1.20,"-")
text(2.05,1.10,"-")
text(2.05,1.00,"-")
text(2.05,0.90,"-")
text(2.05,0.80,"-")
text(2.05,0.70,"-")
text(2.05,0.60,"-")
text(2.05,0.50,"-")
text(2.05,0.40,"-")
text(2.05,0.30,"-")
text(2.05,0.20,"-")
text(2.05,0.10,"-")
text(2.06,2.80,"-")
text(2.15,2.70,"-")
text(2.15,2.60,"-")
text(2.15,2.50,"-")
text(2.15,2.40,"-")
text(2.15,2.30,"-")
text(2.15,2.20,"-")
text(2.15,2.10,"-")
text(2.15,2.00,"-")
text(2.15,1.90,"-")
text(2.15,1.80,"-")
text(2.15,1.70,"-")
text(2.15,1.60,"-")
text(2.15,1.50,"-")
text(2.15,1.40,"-")
text(2.15,1.30,"-")
text(2.15,1.20,"-")
text(2.15,1.10,"-")
text(2.15,1.00,"-")
text(2.15,0.90,"-")
text(2.15,0.80,"-")
text(2.15,0.70,"-")
text(2.15,0.60,"-")
text(2.15,0.50,"-")
text(2.15,0.40,"-")
text(2.15,0.30,"-")
text(2.15,0.20,"-")
text(2.15,0.10,"-")
text(2.20,2.50,"-")
text(2.25,2.40,"-")
text(2.25,2.30,"-")
text(2.25,2.20,"-")
text(2.25,2.10,"-")
text(2.25,2.00,"-")
text(2.25,1.90,"-")
text(2.25,1.80,"-")
text(2.25,1.70,"-")
text(2.25,1.60,"-")
text(2.25,1.50,"-")
text(2.25,1.40,"-")
text(2.25,1.30,"-")
text(2.25,1.20,"-")
text(2.25,1.10,"-")
text(2.25,1.00,"-")
text(2.25,0.90,"-")
text(2.25,0.80,"-")
text(2.25,0.70,"-")
text(2.25,0.60,"-")
text(2.25,0.50,"-")
text(2.25,0.40,"-")
text(2.25,0.30,"-")
text(2.25,0.20,"-")
text(2.25,0.10,"-")
text(2.30,2.30,"-")
text(2.35,2.20,"-")
text(2.35,2.10,"-")
text(2.35,2.00,"-")
text(2.35,1.90,"-")
text(2.35,1.80,"-")
text(2.35,1.70,"-")
text(2.35,1.60,"-")
text(2.35,1.50,"-")
text(2.35,1.40,"-")
text(2.35,1.30,"-")
text(2.35,1.20,"-")
text(2.35,1.10,"-")
text(2.35,1.00,"-")
text(2.35,0.90,"-")
text(2.35,0.80,"-")
text(2.35,0.70,"-")
text(2.35,0.60,"-")
text(2.35,0.50,"-")
text(2.35,0.40,"-")
text(2.35,0.30,"-")
text(2.35,0.20,"-")
text(2.35,0.10,"-")
text(2.45,2.10,"-")
text(2.45,2.00,"-")
text(2.45,1.90,"-")
text(2.45,1.80,"-")
text(2.45,1.70,"-")
text(2.45,1.60,"-")
text(2.45,1.50,"-")
text(2.45,1.40,"-")
text(2.45,1.30,"-")
text(2.45,1.20,"-")
text(2.45,1.10,"-")
text(2.45,1.00,"-")
text(2.45,0.90,"-")
text(2.45,0.80,"-")
text(2.45,0.70,"-")
text(2.45,0.60,"-")
text(2.45,0.50,"-")
text(2.45,0.40,"-")
text(2.45,0.30,"-")
text(2.45,0.20,"-")
text(2.45,0.10,"-")
text(2.50,2.00,"-")
text(2.55,1.90,"-")
text(2.55,1.80,"-")
text(2.55,1.70,"-")
text(2.55,1.60,"-")
text(2.55,1.50,"-")
text(2.55,1.40,"-")
text(2.55,1.30,"-")
text(2.55,1.20,"-")
text(2.55,1.10,"-")
text(2.55,1.00,"-")
text(2.55,0.90,"-")
text(2.55,0.80,"-")
text(2.55,0.70,"-")
text(2.55,0.60,"-")
text(2.55,0.50,"-")
text(2.55,0.40,"-")
text(2.55,0.30,"-")
text(2.55,0.20,"-")
text(2.55,0.10,"-")
text(2.60,1.80,"-")
text(2.65,1.70,"-")
text(2.65,1.60,"-")
text(2.65,1.50,"-")
text(2.65,1.40,"-")
text(2.65,1.30,"-")
text(2.65,1.20,"-")
text(2.65,1.10,"-")
text(2.65,1.00,"-")
text(2.65,0.90,"-")
text(2.65,0.80,"-")
text(2.65,0.70,"-")
text(2.65,0.60,"-")
text(2.65,0.50,"-")
text(2.65,0.40,"-")
text(2.65,0.30,"-")
text(2.60,0.20,"-")
text(2.70,1.60,"-")
text(2.75,1.50,"-")
text(2.75,1.40,"-")
text(2.75,1.30,"-")
text(2.75,1.20,"-")
text(2.75,1.10,"-")
text(2.75,1.00,"-")
text(2.75,0.90,"-")
text(2.75,0.80,"-")
text(2.75,0.70,"-")
text(2.75,0.60,"-")
text(2.75,0.50,"-")
text(2.70,0.40,"-")
text(2.80,1.40,"-")
text(2.85,1.30,"-")
text(2.85,1.20,"-")
text(2.85,1.10,"-")
text(2.85,1.00,"-")
text(2.85,0.90,"-")
text(2.85,0.80,"-")
text(2.85,0.70,"-")
text(2.80,0.60,"-")
text(2.86,1.10,"-")
text(2.86,1.00,"-")
text(2.86,0.90,"-")
dev.off()
dos("copy fig1-3.eps lpt1")
