postscript("fig2-1.eps",width=3.5,height=2.5,pointsize=7)
par(mfrow=c(1,1),lab=c(8,3,3))
t<-c(-2,-1.5,-1,-.5,0,.5,1,1.5,2)
r<-c(1,16,39,71,130,126,107,57,36)
f<-c(36,59,109,157,178,157,109,59,36)
op<-r/f
plot(t,op,type="p",xlim=c(-3,3),ylim=c(0,1),
xlab="",ylab="",axes=F,bty="l")
par(new=T)
theta<-seq(-3,3,.1)
alpha<-.9714
beta<--.5485
z<-alpha*(theta-beta)
p<-pnorm(z,0,1)
plot(theta,p,type="l",xlim=c(-3,3),ylim=c(0,1),
xlab="Ability",ylab="Probability of Correct Response",bty="l")
dev.off()
dos("copy fig2-1.eps lpt1")
