postscript("fig3-1.eps",width=3.5,height=2.5,pointsize=7)
par(mfrow=c(1,1),lab=c(8,3,3))
theta<-seq(-3,3,.1)
alpha<-.9
beta<-0
z<-alpha*(theta-beta)
h<-dnorm(z,0,1)
p<-pnorm(z,0,1)
i<-alpha*alpha*h*h/(p*(1-p))
plot(theta,i,type="l",xlim=c(-3,3),ylim=c(0,1),
xlab="Ability",ylab="Item Information",bty="l")
dev.off()
dos("copy fig3-1.eps lpt1")
