postscript("fig3-2.eps",width=3.5,height=2.5,pointsize=7)
par(mfrow=c(1,1),lab=c(8,3,3))
theta<-seq(-3,3,.1)
alpha<-.8
beta<-0
c<-.2
p2<-1/(1+exp(-alpha*(theta-beta)))
p<-c+(1-c)*p2
q<-1-p
i<-alpha*alpha*p*q*(p2/p)**2
plot(theta,i,type="l",xlim=c(-3,3),ylim=c(0,1),
xlab="Ability",ylab="Item Information",bty="l")
dev.off()
dos("copy fig3-2.eps lpt1")
