postscript("fig6-1.eps",width=3.5,height=2.5,pointsize=7)
par(mfrow=c(1,1),lab=c(8,5,3))
x<-rnorm(50000)
hist(x,nclass=8,xlim=c(-4.0,4.0),ylim=c(0,23000),
xlab="",ylab="",main="",axes=F)
theta<-seq(-4.0,4.0,.1)
g<-dnorm(theta,0,1)
par(new=T)
plot(theta,g,type="l",xlim=c(-4.0,4.0),ylim=c(0,.5),
xlab="Ability",ylab="Height of Density",bty="l")
text(-3.50,.04,"X")
text(-3.35,.025,"1",cex=.7)
text(-2.50,.04,"X")
text(-2.35,.025,"2",cex=.7)
text(-1.50,.04,"X")
text(-1.35,.025,"3",cex=.7)
text(-0.50,.04,"X")
text(-0.35,.025,"4",cex=.7)
text(0.50,.04,"X")
text(0.65,.025,"5",cex=.7)
text(1.50,.04,"X")
text(1.65,.025,"6",cex=.7)
text(2.50,.04,"X")
text(2.65,.025,"7",cex=.7)
text(3.50,.04,"X")
text(3.65,.025,"8",cex=.7)
dev.off()
dos("copy fig6-1.eps lpt1")
