postscript("fig8-2.eps",width=3.5,height=2.5,pointsize=7)
par(mfrow=c(1,1),lab=c(8,3,3))
theta<-seq(-3,3,.1)
p0<-1
p1<-pnorm(theta,-2,2)
p2<-pnorm(theta,0,2)
p3<-pnorm(theta,2,2)
p4<-0
pk1<-p0-p1
pk2<-p1-p2
pk3<-p2-p3
pk4<-p3-p4
plot(theta,pk1,type="l",xlim=c(-3,3),ylim=c(0,1),xlab="Ability",
  ylab="Probability of Response Category",bty="l")
par(new=T)
plot(theta,pk2,type="l",xlim=c(-3,3),ylim=c(0,1),xlab="",ylab="",bty="l")
par(new=T)
plot(theta,pk3,type="l",xlim=c(-3,3),ylim=c(0,1),xlab="",ylab="",bty="l")
par(new=T)
plot(theta,pk4,type="l",xlim=c(-3,3),ylim=c(0,1),xlab="",ylab="",bty="l")
text(-2.8,.71,"1")
text(-1.0,.44,"2")
text(1.0,.44,"3")
text(2.8,.71,"4")
dev.off()
dos("copy fig8-2.eps lpt1")
