100 REM PROGRAM TO IMPLEMENT MMLE/EM FOR LSAT-6 DATA SET
110 DIM U(32,5),X(10),AK(10),FPT(32),LXK(32,10),PL(32)
120 DIM RIK(5,10),NK(5,10),PQ(10),CPT(5),A(5),B(5)
130 GOSUB 1500:REM READ CANNED DATA AND SET TRACES
140 FOR NC=1 TO MNC
150 PRINT:PRINT "CYCLE= ";NC:PRINT "CYCLE= ";NC
155 FOR L=1 TO 32:PL(L)=0:FOR K=1 TO 10:LXK(L,K)=1:NEXT K:NEXT L
160 REM E-STEP   GET EXPECTED R AND N
170 GOSUB 300
180 REM M-STEP   MLE OF ITEM PARAMETERS
190 FOR I=1 TO 5
200 GOSUB 1000
210 NEXT I
220 NEXT NC
230 REM DONE MAX CYCLES
240 GOSUB 1700
250 STOP
REM *******END OF DRIVER SECTION********
299 REM E STEP SUBROUTINE
300 FOR L=1 TO 32
310 FOR K=1 TO 10
320 FOR I=1 TO 5
330 GOSUB 600
340 PQ(I)=P:IF U(L,I)=0 THEN PQ(I)=Q
342 IF TRALL<>0 GOTO 360
345 PRINT "345";TAB(5);L;TAB(10);K;TAB(15);I;TAB(20);PQ(I);TAB(40);U(L,I)
360 LXK(L,K)=LXK(L,K)*PQ(I)
370 NEXT I
375 IF (TRALL=0)OR(TRLP=0) THEN PRINT "L= ";L;TAB(10);"K= ";K;TAB(20);"L(X)= ";LXK(L,K)
380 NEXT K
390 PL(L)=0:FOR K=1 TO 10:PL(L)=PL(L)+LXK(L,K)*AK(K)
391 IF TRALL<>0 GOTO 395
392 PRINT "392";TAB(5);L;TAB(10);PL(L);TAB(35);LXK(L,K);TAB(50);AK(K)
395 NEXT K
398 IF (TRALL=0) OR(TRLP=0) THEN PRINT TAB(10);"PL(";L;")= ";PL(L)
400 NEXT L
410 REM R BAR AND N BAR LOOP
420 FOR I=1 TO 5
425 IF (TRALL=0) OR (TRRN=0) THEN PRINT TAB(10);"ITEM ";I
430 FOR K=1 TO 10
435 RIK(I,K)=0:NK(I,K)=0
440 FOR L=1 TO 32:NT=FPT(L)*LXK(L,K)*AK(K)/PL(L):RT=NT*U(L,I):RIK(I,K)=RIK(I,K)+RT:NK(I,K)=NK(I,K)+NT
441 IF TRALL<>0 GOTO 448
442 PRINT "442";TAB(5);I;TAB(8);K;TAB(12);L;TAB(17);LXK(L,K);TAB(33);AK(K);TAB(50);PL(L)
444 PRINT "444";TAB(5);U(L,I);TAB(8);NT;TAB(24);RT;TAB(39);RT
446 PRINT "446";TAB(5);RIK(I,K);TAB(25);NK(I,K)
448 NEXT L
449 IF (TRALL=0)OR(TRRN=0) THEN PRINT "449 ";TAB(8);"X(";K;")= ";X(K);TAB(25);"R= ";RIK(I,K);TAB(43);"N= ";NK(I,K)
450 NEXT K
460 NEXT I
470 RETURN
REM ***SUBROUTINE TO COMPUTE P(X)***
600 DEV=-(CPT(I)+A(I)*X(K))
610 EP=EXP(DEV)
620 P=1/(1+EP):Q=1-P:RETURN
999 REM E-STEP --ITEMBIO ROUTINE FOR ESTIMATION OF ITEM PARAMETERS
1000 FOR NIT=1 TO 6
1040 SNW=0:SNWV=0:SNWX=0:SNWXV=0:SNWX2=0:SNWV2=0
1050 FOR K=1 TO 10:REM THETA LOOP
1060 IF NK(I,K)=0 GOTO 1180
1070 PI=RIK(I,K)/NK(I,K)
1135 REM CALCULATE NEWTON-RAPHSON TERMS
1140 DV=CPT(I)+A(I)*X(K):REM CPT=INTERCEPT:A=SLOPE
1142 PH=1/(1+EXP(-DV)):W=PH*(1-PH):IF W<.0000009 GOTO 1180
1145 V=(PI-PH)/W:IF TRALL<>0 GOTO 1160
1150 PRINT "X(";K;")= ";X(K);TAB(17);"PI= ";PI;TAB(30);"P HAT= ";PH
1155 PRINT TAB(17);"W= ";W;TAB(40);"V= ";V
1160 P1=NK(I,K)*W:P2=P1*V:P3=P2*V:P4=P1*X(K):P5=P4*X(K):P6=P4*V
1170 SNW=SNW+P1:SNWV=SNWV+P2:SNWX=SNWX+P4:SNWXV=SNWXV+P6:SNWX2=SNWX2+P5:SNWV2=SNWV2+P3
1171 IF TRALL<>0 GOTO 1180
1172 PRINT TAB(5);"P1=";P1;TAB(25);"P2= ";P2;TAB(40);"P3= ";P3
1173 PRINT TAB(5);"P4=";P4;TAB(25);"P5="P5;TAB(40);"P6=";P6
1174 PRINT TAB(5);"SNW= ";SNW;TAB(25);"SNWV= ";SNWV;TAB(45);"SNWX= ";SNWX
1175 PRINT TAB(5);"SNWXV= ";SNWXV;TAB(25);"SNWX2= ";SNWX2;TAB(45);"SNWV2= ";SNWV2
1180 NEXT K
1190 IF SNW<=0 GOTO 1350
1200 DM=SNW*SNWX2-SNWX*SNWX:IF TRALL<>0 GOTO 1230
1210 PRINT "DENOMINATOR= ";DM
1230 IF DM<=.000099 GOTO 1350
1240 DCPT=(SNWV*SNWX2-SNWXV*SNWX)/DM
1250 DA=(SNW*SNWXV-SNWX*SNWV)/DM
1270 CPT(I)=CPT(I)+DCPT:A(I)=A(I)+DA
1275 IF (TRALL=0) OR (TRMLE=0) THEN
      PRINT "NIT= ";NIT;" ITEM= ";I
      PRINT TAB(9);"INTERCEPT= ";CPT(I);TAB(32);"CHANGE= ";DCPT
      PRINT TAB(9);"SLOPE= ";A(I);TAB(32);"CHANGE= ";DA
	ELSE
	END IF
1290 IF(ABS(CPT(I))>30)OR(ABS(A(I))>20) GOTO 1350
1300 IF(ABS(DCPT)<=.05)AND(ABS(DA)<=.05) GOTO 1340
1330 NEXT NIT
1340 RETURN
1350 PRINT "  OUT OF BOUNDS ERROR ITERATION ";NIT:GOTO 1340
REM**********READ CANNED DATA AND SET TRACES**********8
1500 FOR L=1 TO 32:FOR I=1 TO 5:READ U(L,I):NEXT I:NEXT L
1510 FOR K=1 TO 10:READ X(K):NEXT K
1520 FOR K=1 TO 10:READ AK(K):NEXT K
1530 FOR L=1 TO 32:READ FPT(L):NEXT L
1540 FOR I=1 TO 5:READ CPT(I),A(I):NEXT I
1550 REM SET UP TRACEING
1560 TRALL=-1:TRLP=-1:TRRN=-1:TRMLE=-1
1570 INPUT "TRACE ALL? Y/N ";YN$
1580 IF (YN$="Y") OR (YN$="y") THEN TRALL=0:TRLP=0:TRRN=0:TRMLE=0:GOTO 1650
1590 INPUT "TRACE L,P? Y/N ";YN$
1600 IF (YN$="Y")OR(YN$="y") THEN TRLP=0
1610 INPUT "TRACE R AND N? Y/N ";YN$
1620 IF (YN$="Y") OR (YN$="y") THEN TRRN=0
1630 INPUT "TRACE MLE? Y/N ";YN$
1640 IF (YN$="Y") OR (YN$="y") THEN TRMLE=0
1650 INPUT "ENTER NUMBER OF CYCLES TO DO ";MNC
1670 CLS:PRINT " ALL  LP  TRRN  MLE    MAX CYCLES"
1680 PRINT TAB(2);TRALL;TAB(6);TRLP;TAB(11);TRRN;TAB(17);TRMLE;TAB(23);MNC
1690 RETURN
REM *************PRINT ITEM PRAMTER ESTIMATES**************
1700 PRINT "  ITEM";TAB(10);"INTERCEPT";TAB(28);"SLOPE ";TAB(43);"DIFFICULTY"
1710 FOR I=1 TO 5
1720 B(I)=-CPT(I)/A(I)
1730 PRINT TAB(5);I;TAB(10);CPT(I);TAB(25);A(I);TAB(40);B(I)
1740 NEXT I
1750 RETURN
REM **********CANNED DATA****************
9000 DATA 0,0,0,0,0
9010 DATA 0,0,0,0,1
9020 DATA 0,0,0,1,0
9030 DATA 0,0,0,1,1
9040 DATA 0,0,1,0,0
9050 DATA 0,0,1,0,1
9060 DATA 0,0,1,1,0
9070 DATA 0,0,1,1,1
9080 DATA 0,1,0,0,0
9090 DATA 0,1,0,0,1
9100 DATA 0,1,0,1,0
9110 DATA 0,1,0,1,1
9120 DATA 0,1,1,0,0
9130 DATA 0,1,1,0,1
9140 DATA 0,1,1,1,0
9150 DATA 0,1,1,1,1
9160 DATA 1,0,0,0,0
9170 DATA 1,0,0,0,1
9180 DATA 1,0,0,1,0
9190 DATA 1,0,0,1,1
9200 DATA 1,0,1,0,0
9210 DATA 1,0,1,0,1
9220 DATA 1,0,1,1,0
9230 DATA 1,0,1,1,1
9240 DATA 1,1,0,0,0
9250 DATA 1,1,0,0,1
9260 DATA 1,1,0,1,0
9270 DATA 1,1,0,1,1
9280 DATA 1,1,1,0,0
9290 DATA 1,1,1,0,1
9300 DATA 1,1,1,1,0
9310 DATA 1,1,1,1,1
9400 REM QUADRATURE POINTS AND WEIGHTS VIA BILOG
9410 DATA -4.00,-3.111,-2.222,-1.333,-.4444,.4444,1.333,2.2222
9420 DATA 3.111,4.000
9430 DATA .000119,.002805,.03002,.1458,.3213,.3213,.1458,.03002
9450 DATA .002805,.000119
9500 DATA 3,6,2,11,1,1,3,4,1,8,0,16,0,3,2,15,10,29,14,81,3,28,15
9510 DATA 80,16,56,21,173,11,61,28,298
10000 DATA 0,1,0,1,0,1,0,1,0,1

