100 REM PROGRAM TO IMPLMENT BAYESIAN "EXPECTED A POSTERIORI" ABILITY ESTIMATION
105 REM USES B=DIFFICULTY,A=DISCRIMNATION LSAT -6 DATA
110 DIM U(5),X(10),AK(10),LXK(10)
120 DIM RIK(5,10),NK(5,10),PITEM(10),A(5),B(5)
130 GOSUB 1500:REM READ CANNED DATA AND SET TRACES
155 FOR K=1 TO 10:LXK(K)=1:NEXT K
160 REM BAYESIAN "EXPECTED A POSTERIORI" ESTIMATION OF ABILITY
170 GOSUB 300
180 PRINT:PRINT "ESTIMATED THETA= ";THETA
190 STOP
REM **************END OF DRIVER SECTION*********
299 REM EAP ESTIMATION SUBROUTINE
300 FOR K=1 TO 10
310 FOR I=1 TO 5
320 GOSUB 600:REM EVALUATE TWO-PARAMETER ICC
330 PITEM=P:IF U(I)=0 THEN PITEM=Q
340 LXK(K)=LXK(K)*PITEM
350 IF TRALL<>0 GOTO 370
360 PRINT TAB(5);"K= ";K;TAB(12);"I= ";I;TAB(18);"U= ";U(I);TAB(25);"P= ";PITEM;TAB(42);" L(X)= ";LXK(K)
370 NEXT I
380 IF (TRALL=0)OR(TRLS=0) THEN PRINT "K= ";K;TAB(10);"L(X)= ";LXK(K)
390 NEXT K
400 SNUM=0:SDEN=0
410 FOR K=1 TO 10
420 LA=LXK(K)*AK(K)
430 XLA=X(K)*LA
440 SNUM=SNUM+XLA
450 SDEN=SDEN+LA
460 IF TRALL<>0 GOTO 500
470 PRINT "K= ";K
480 PRINT TAB(5);"LXK(K)= ";LXK(K);TAB(30);"AK(K)= ";AK(K);TAB(50);"X(K)= ";X(K)
490 PRINT TAB(5);"LA= ";LA;TAB(25);"XLA= ";XLA
500 IF(TRALL=0) OR (TRLS=0) THEN PRINT "K= ";K;TAB(10);"SUM NUMERATOR= ";SNUM;TAB(40);"SUM DENOMINATOR= ";SDEN
510 NEXT K
520 THETA=SNUM/SDEN
530 RETURN
REM ******ROUTINE TO COMPUTE P(X)******
600 DEV=-A(I)*(X(K)-B(I))
610 P=1/(1+EXP(DEV)):Q=1-P
620 RETURN
REM**********READ CANNED DATA AND SET TRACES*******
1500 FOR I=1 TO 5:READ U(I):NEXT I
1510 FOR K=1 TO 10:READ X(K):NEXT K
1520 FOR K=1 TO 10:READ AK(K):NEXT K
1530 FOR I=1 TO 5:READ B(I),A(I):NEXT I
1540 REM SET UP TRACEING
1550 TRALL=-1:TRLS=-1
1560 INPUT "TRACE ALL? Y/N ";YN$
1570 IF (YN$="Y")OR(YN$="y") THEN TRALL=0:TRLS=0:GOTO 1600
1580 INPUT "TRACE L AND SUMS? Y/N ";YN$
1590 IF (YN$="Y")OR(YN$="y") THEN TRLS=0
1600 PRINT "TRACE: ALL    L AND SUMS"
1610 PRINT TAB(7);TRALL;TAB(15);TRLS
1620 CLS:RETURN
8999 REM EXAMINEE'S ITEM RESPONSE PATTERN
9000 DATA 1,0,1,0,1
9010 REM QUADRATURE POINTS AND WEIGHTS VIA BILOG
9020 DATA -4.000,-3.111,-2.222,-1.333,-.4444,.4444,1.333,2.222
9030 DATA 3.111,4.000
9040 DATA .000119,.002805,.03002,.1458,.3213,.3213,.1458,.03002
9050 DATA .002805,.000119
9060 REM INITIAL VALUES FOR B(I) AND A(I)
9070 DATA -3.283,.849,-1.317,.758,-.285,.870,-1.766,.736,-2.858,.730

