100 REM PROGRAM TO ESTIMATE ABILTY UNDER GRADED RESPONSE MODEL
110 REM FIVE FOUR-RESPONSE TEST ITEMS
120 DIM A(5),CPT(5,3),U(5)
130 GOSUB 4500:REM READ CANNED DATA AND SET TRACES
140 SD=0:FSD=0:PRINT TAB(5);"INITIAL THETA= ";THETA
150 FOR NIT= 1 TO MAXIT
160 PRINT:PRINT "MLE ITERATION ";NIT
170 FOR I= 1 TO NITEM:TERM4=0
180 FOR K=1 TO MRC
190 IF U(I) <> K GOTO 230
200 PTSFLG$="N":GOSUB 4700:REM CALC P'S AND W'S
210 IF PTSFLG$="Y" GOTO 230
220 GOSUB 5000:REM CALC FIRST AND SECOND DERIVATIVE TERMS
230 NEXT K
240 NEXT I
250 DELTA=FDS/SDS:THETA=THETA-DELTA
260 IF(TRALL=0) OR (TRMLE=0) THEN PRINT "THETA= ";THETA;" DELTA= ";DELTA
270 IF ABS(DELTA) < .05 GOTO 300
280 NEXT NIT
290 PRINT "MAX CYCLES REACHED"
300 PRINT "THETA ESTIMATE= ";THETA
310 END
REM******* READ CANNED DATA AND SET TRACES***********
4500 MRC=4:MBC=3:NITEM=5:MAXIT=10:THETA=.4:REM INITIAL VALUE OF THETA
4510 FOR I=1 TO NITEM:READ A(I)
4520 FOR K= 1 TO MBC:READ CPT(I,K)
4530 NEXT K:NEXT I
4540 FOR I= 1 TO NITEM:READ U(I):NEXT I
4550 TRALL=-1:INPUT "TRACE ALL? Y/N ";YN$
4560 IF YN$="N" GOTO 4580
4570 TRALL=0:TRMLE=0:GOTO 4595
4580 INPUT "TRACE MLE? Y/N ";YN$
4590 TRMLE=-1:IF YN$= "Y" THEN TRMLE=0
4595 PRINT "ALL    MLE   MAX CYCLES":PRINT TRALL;TAB(8);TRMLE;TAB(15);MAXIT
4599 RETURN
REM*******CALCULATE P'S  AND W'S**********************
4700 KM1=K-1
4710 IF KM1=0 THEN
	PSTRKM1=1.0:WKML1=0
     ELSE
	DEVKM1=CPT(I,KM1)+A(I)*THETA
	PSTRKM1=1.0/(1.0+EXP(-DEVKM1))
	WKM1=PSTRKM1*(1.0-PSTRKM1)
     END IF
4720 IF K=MRC THEN
	PSTRK=0:WK=0
     ELSE
	DEV=CPT(I,K)+A(I)*THETA
	PSTRK=1.0/(1.0+EXP(-DEV))
	WK=PSTRK*(1.0-PSTRK)
     END IF
4730 PK=PSTRKM1-PSTRK
4740 IF TRALL= -1 GOTO 4780
4750 PRINT "ITEM(";I;")";"    U(I)= ";U(I)
4760 PRINT "K-1= ";KM1;" DEV(K-1)= ";DEVKM1" P*(K-1)= ";PSTRKM1;" W(K-1)= ";WKM1
4770 PRINT "K= ";K;" DEV(K)= ";DEV;" PSTAR(K)= ";PSTRK;" P(K)= ";PK;" W(K)= ";WK
4780 IF (PK <.0001) OR (PK > .9999) THEN PTSFLG$="Y"
4790 RETURN
REM********FIRST DERIVATE************
5000 FTERM=(WKM1-WK)/PK
5010 FDS=FDS+FTERM
5020 IF TRALL =-1 GOTO 5040
5030 PRINT "FTERM= ";FTERM;" FIRST DERIVATIVE SUM= ";FDS
REM*******SECOND DERIVATIVE***********
5040 TERM1=-WK*(1.0-2*PSTRK)/PK
5050 TERM2= WKM1*(1.0-2*PSTRKM1)/PK
5060 TERM3= -(WKM1-WK)*(WKM1-WK)/(PK*PK)
5070 TERM4=TERM4+TERM1+TERM2+TERM3
5080 SDS=SDS+A(I)*A(I)*TERM4
5090 IF TRALL=-1 GOTO 5120
5100 PRINT "TERM1= ";TERM1;" TERM2= ";TERM2;" TERM3= ";TERM3
5110 PRINT TAB(10);"TERM4= ";TERM4;" SDS= ";SDS
5120 RETURN
REM*********CANNED DATA************
9010 DATA .85,1.72,0.0,-1.720
9020 DATA 1.0,1.20,.2,-1.5
9030 DATA .90,2.1,1.1,-.70
9040 DATA 1.1,-.6,-.8,-1.2
9050 DATA 1.4,1.4,.7,-1.7
9060 DATA 3,2,3,4,3

