'     PROGRAM TO IMPLEMENT MARGINAL MAXIMUM LIKELIHOOD RASCH
'     INVERSE WHOLE MATRIX

      TRALL = -1
      INPUT "TRACE ALL? Y/N "; YN$
      IF (YN$ = "Y") OR (YN$ = "y") THEN TRALL = 0
100   INPUT "ENTER NUMBER OF EM CYCLES "; MNC
      IF (MNC <= 0) THEN GOTO 100

      NI = 5
      NG = 6
'     G=0(1)5
      NL = 10
      NIT = 24
'     NIT = 4 * (NI + 1)
      CRITIT = .0001
      CRITNC = .001

      DIM RP(NG, NI), N(NG), X(NL), PHIX(NL), B(NI)
      DIM CX(NG, NL), PRODP(NL), SCXPHIX(NL), LX(NG, NL)
      DIM R1(NL, NI), R0(NL, NI), P(NL, NI), DB(NI), DDB(NI)
      DIM DDC(NI), DDI(NI + 1, NI + 1)
      DIM OLDB(NI), DELTAB(NI)

      FOR L = 1 TO NL
        READ X(L)
      NEXT L
      DATA -4.5, -3.5, -2.5, -1.5, -0.5, 0.5, 1.5, 2.5, 3.5, 4.5

      FOR G = 0 TO (NG - 1)
        FOR I = 1 TO NI
          READ RP(G, I)
        NEXT I
      NEXT G
      DATA 0.0, 0.0, 0.0, 0.0, 0.0
      DATA 10.0, 1.0, 1.0, 2.0, 6.0
      DATA 62.0, 24.0, 7.0, 28.0, 49.0
      DATA 212.0, 109.0, 63.0, 139.0, 188.0
      DATA 342.0, 277.0, 184.0, 296.0, 329.0
      DATA 298.0, 298.0, 298.0, 298.0, 298.0

      FOR G = 0 TO (NG - 1)
        READ N(G)
      NEXT G
      DATA 3.0, 20.0, 85.0, 237.0, 357.0, 298.0

'     INITIAL VALUES
      A = 1!
      B(1) = 0!
      B(2) = 0!
      B(3) = 0!
      B(4) = 0!
      B(5) = 0!
      SUMN = 0!
      FOR G = 0 TO (NG - 1)
        SUMN = SUMN + N(G)
      NEXT G
      FOR I = 1 TO NI
        FOR G = 0 TO (NG - 1)
          B(I) = B(I) + RP(G, I)
        NEXT G
        B(I) = LOG((SUMN - B(I)) / B(I))
      NEXT I
      PRINT
      PRINT "INITIAL B(I)"
      PRINT
      PRINT "         I      B(I)"
      FOR I = 1 TO NI
        PRINT USING "####.#####"; I; B(I)
      NEXT I

      FOR L = 1 TO NL
        PI = 3.141592654#
        PHIX(L) = (1! / (SQR(2! * PI))) * EXP(-(1! / 2!) * X(L) * X(L))
      NEXT L

      NC = 1
1000  PRINT
      PRINT "CYCLE= "; NC

      FOR I = 1 TO NI
        OLDB(I) = B(I)
      NEXT I
      OLDA = A
'     FOR CRITNC

      FOR L = 1 TO NL
        PRODP(L) = 1!
        FOR I = 1 TO NI
          P(L, I) = 1! / (1! + EXP(-A * (X(L) - B(I))))
          PRODP(L) = PRODP(L) * P(L, I)
        NEXT I
      NEXT L

      FOR G = 0 TO (NG - 1)
        FOR L = 1 TO NL
          CX(G, L) = PRODP(L) * EXP(-(NI - G) * A * X(L))
'         PRINT "G= "; G; "  L= "; L; "  CX(G,L)="; CX(G, L)
        NEXT L
      NEXT G

      FOR G = 0 TO (NG - 1)
      SCXPHIX(G) = 0!
        FOR L = 1 TO NL
          SCXPHIX(G) = SCXPHIX(G) + CX(G, L) * PHIX(L)
        NEXT L
      NEXT G

      FOR G = 0 TO (NG - 1)
        FOR L = 1 TO NL
          LX(G, L) = CX(G, L) * PHIX(L) / SCXPHIX(G)
        NEXT L
      NEXT G

      FOR L = 1 TO NL
        FOR I = 1 TO NI
          R1(L, I) = 0!
          R0(L, I) = 0!
          FOR G = 0 TO (NG - 1)
            R1(L, I) = R1(L, I) + RP(G, I) * LX(G, L)
            R0(L, I) = R0(L, I) + (N(G) - RP(G, I)) * LX(G, L)
          NEXT G
        NEXT I
      NEXT L

      FOR IT = 1 TO NIT

        IF TRALL = 0 THEN
          PRINT
          PRINT "ITERATION= "; IT
          PRINT
          PRINT "           I        B(I)       DB(I)      DDB(I)"
        END IF
        FOR I = 1 TO NI
          DB(I) = 0!
          DDB(I) = 0!
          FOR L = 1 TO NL
            P(L, I) = 1! / (1! + EXP(-A * (X(L) - B(I))))
            DB(I) = DB(I) + A * (R0(L, I) * P(L, I) - R1(L, I) * _
              (1! - P(L, I)))
            DDB(I) = DDB(I) - A * A * P(L, I) * (1! - P(L, I)) * _
              (R0(L, I) + R1(L, I))
          NEXT L
          IF TRALL = 0 THEN
            PRINT USING "######.#####"; I; B(I); DB(I); DDB(I)
          END IF
        NEXT I

        IF TRALL = 0 THEN
          PRINT
          PRINT "           A          DA         DDA"
        END IF
        DA = 0!
        DDA = 0!
        FOR L = 1 TO NL
          FOR I = 1 TO NI
            P(L, I) = 1! / (1! + EXP(-A * (X(L) - B(I))))
            DA = DA + (X(L) - B(I)) * (R1(L, I) * (1! - P(L, I)) _
              - R0(L, I) * P(L, I))
            DDA = DDA - (X(L) - B(I)) * (X(L) - B(I)) * P(L, I) _
              * (1! - P(L, I)) * (R0(L, I) + R1(L, I))
          NEXT I
        NEXT L
        IF TRALL = 0 THEN
          PRINT USING "######.#####"; A; DA; DDA
        END IF

        IF TRALL = 0 THEN
          PRINT
          PRINT "           I      DDC(I)"
        END IF
        FOR I = 1 TO NI
        DDC(I) = 0!
          FOR L = 1 TO NL
            P(L, I) = 1! / (1! + EXP(-A * (X(L) - B(I))))
            DDC(I) = DDC(I) + (R0(L, I) * P(L, I) - R1(L, I) * _
              (1! - P(L, I))) + A * P(L, I) * (1! - P(L, I)) * _
              (X(L) - B(I)) * (R0(L, I) + R1(L, I))
          NEXT L
          IF TRALL = 0 THEN
            PRINT USING "######.#####"; I; DDC(I)
          END IF
        NEXT I

        IF TRALL = 0 THEN
          PRINT
          PRINT "INVERSE HESSIAN"
        END IF
        DDI(NI + 1, NI + 1) = 0!
        FOR I = 1 TO NI
          DDI(NI + 1, NI + 1) = DDI(NI + 1, NI + 1) + DDC(I) * _
            (1! / DDB(I)) * DDC(I)
        NEXT I
        DDI(NI + 1, NI + 1) = 1! / (DDA - DDI(NI + 1, NI + 1))
        FOR I = 1 TO NI
          DDI(I, NI + 1) = -(1! / DDB(I)) * DDC(I) * DDI(NI + 1, NI + 1)
          DDI(NI + 1, I) = -DDI(NI + 1, NI + 1) * DDC(I) / DDB(I)
        NEXT I
        FOR I = 1 TO NI
          FOR II = 1 TO NI
            DDI(I, II) = (1! / DDB(I)) * DDC(I) * _
              DDI(NI + 1, NI + 1) * (DDC(II) / DDB(II))
          NEXT II
        NEXT I
        FOR I = 1 TO NI
          DDI(I, I) = (1! / DDB(I)) + DDI(I, I)
        NEXT I
        IF TRALL = 0 THEN
          FOR I = 1 TO NI + 1
            PRINT USING "####.#####"; DDI(I, 1); DDI(I, 2); _
              DDI(I, 3); DDI(I, 4); DDI(I, 5); DDI(I, 6)
'           ABOVE BASED ON NI
          NEXT I
        END IF

        FOR I = 1 TO NI
          DELTAB(I) = (DDI(I, 1) * DB(1) + DDI(I, 2) * DB(2) + _
            DDI(I, 3) * DB(3) + DDI(I, 4) * DB(4) + _
            DDI(I, 5) * DB(5) + DDI(I, 6) * DA)
          B(I) = B(I) - DELTAB(I)
        NEXT I
        DELTAA = (DDI(NI + 1, 1) * DB(1) + DDI(NI + 1, 2) * DB(2) _
          + DDI(NI + 1, 3) * DB(3) + DDI(NI + 1, 4) * DB(4) _
          + DDI(NI + 1, 5) * DB(5) + DDI(NI + 1, 6) * DA)
        A = A - DELTAA

        IF (TRALL = 0) THEN
          PRINT
          PRINT "         I      B(I)"
          FOR I = 1 TO NI
            PRINT USING "####.#####"; I; B(I)
          NEXT I
          PRINT
          PRINT "         A"
          PRINT USING "####.#####"; A
        ELSE
        ENDIF

        DIFFIT = 0!
        FOR I = 1 TO NI
          IF (ABS(DELTAB(I)) > DIFFIT) THEN
            DIFFIT = ABS(DELTAB(I))
          END IF
        NEXT I
        IF (ABS(DELTAA) > DIFFIT) THEN
          DIFFIT = ABS(DELTAA)
        END IF
        IF (TRALL = 0) THEN
          PRINT
          PRINT "        IT    DIFFIT"
          PRINT USING "####.#####"; IT; DIFFIT
        END IF
        IF (DIFFIT < CRITIT) THEN GOTO 899

      NEXT IT

899   IF (TRALL = -1) THEN
        PRINT
        PRINT "         I      B(I)"
        FOR I = 1 TO NI
          PRINT USING "####.#####"; I; B(I)
        NEXT I
        PRINT
        PRINT "         A"
        PRINT USING "####.#####"; A
      END IF
      DIFFNC = ABS(A - OLDA)
      FOR I = 1 TO NI
        IF (ABS(B(I) - OLDB(I)) > DIFFNC) THEN
          DIFFNC = ABS(B(I) - OLDB(I))
        END IF
      NEXT I
      IF (DIFFNC < CRITNC) THEN
        PRINT
        PRINT "EM CYCLE CONVERGED AT NC= "; NC
        NC = MNC
      END IF
'     CRITNC MAY NOT BE EMPLOYED
      PRINT
      PRINT "        NC    DIFFNC"
      PRINT USING "####.#####"; NC; DIFFNC
      NC = NC + 1
      IF NC <= MNC GOTO 1000
      
      END                       
