postscript("fig3-3.eps",width=3.5,height=2.5,pointsize=7)
par(mfrow=c(1,1),lab=c(8,3,3))
theta<-seq(-3,3,.1)
alpha<-1
meanbeta<-0
varbeta<-1
n<-60
sigma<-sqrt(varbeta+1/(alpha**2))
i<-(n*alpha/sigma)*dnorm(theta,meanbeta,sigma)
plot(theta,i,type="l",xlim=c(-3,3),ylim=c(0,60),
xlab="Ability",ylab="Test Information",bty="l")
dev.off()
dos("copy fig3-3.eps lpt1")
