postscript("fig5-1.eps",width=3.5,height=2.5,pointsize=7)
par(mfrow=c(1,1),lab=c(8,3,3))
eta<-seq(.1,10,.1)
delta<-1.822
xi<-eta/delta
p<-xi/(1+xi)
plot(eta,p,type="l",xlim=c(0,10.0),ylim=c(0,1),
xlab="Ability Scale",ylab="Probability of Correct Response",bty="l")
dev.off()
dos("copy fig5-1.eps lpt1")
