postscript("fig5-2.eps",width=3.5,height=2.5,pointsize=7)
par(mfrow=c(1,1),lab=c(8,3,3))
theta<-seq(-3,3,.1)
delta<-1.822
p<-1/(1+exp(-(theta-log(delta))))
plot(theta,p,type="l",xlim=c(-3,3),ylim=c(0,1),
xlab="Log Ability Score",ylab="Probability of Correct Response",bty="l")
dev.off()
dos("copy fig5-2.eps lpt1")
