postscript("fig8-1.eps",width=3.5,height=3.5,pointsize=7)
par(mfrow=c(1,1),lab=c(8,8,3))
theta<-seq(-2.1,2.1,.1)
g0<-2.5*dnorm(theta,0,1)-.05
g00<-0*theta
plot(g0,theta,type="l",xlim=c(-3,3),ylim=c(-3,3),xlab="Ability",
  ylab="Gamma",bty="l")
par(new=T)
plot(g00,theta,type="l",xlim=c(-3,3),ylim=c(-3,3),xlab="",
  ylab="",bty="l")
theta2<-theta+1
g2<-g0+2
g22<-g00+2
par(new=T)
plot(g2,theta2,type="l",xlim=c(-3,3),ylim=c(-3,3),xlab="",
  ylab="",bty="l")
par(new=T)
plot(g22,theta2,type="l",xlim=c(-3,3),ylim=c(-3,3),xlab="",
  ylab="",bty="l")
theta1<-theta-1
g1<-g0-2
g11<-g00-2
par(new=T)
plot(g1,theta1,type="l",xlim=c(-3,3),ylim=c(-3,3),xlab="",
  ylab="",bty="l")
par(new=T)
plot(g11,theta1,type="l",xlim=c(-3,3),ylim=c(-3,3),xlab="",
  ylab="",bty="l")
t<-seq(-3.1,3.1,.1)
gl<-.5*t
l1<-0*t+1
l0<-0*t
l2<-0*t-1
par(new=T)
plot(t,gl,type="l",xlim=c(-3,3),ylim=c(-3,3),xlab="",ylab="",bty="l")
par(new=T)
plot(t,l1,type="l",lty=2,xlim=c(-3,3),ylim=c(-3,3),xlab="",
  ylab="",bty="l")
par(new=T)
plot(t,l0,type="l",lty=2,xlim=c(-3,3),ylim=c(-3,3),xlab="",
  ylab="",bty="l")
par(new=T)
plot(t,l2,type="l",lty=2,xlim=c(-3,3),ylim=c(-3,3),xlab="",
  ylab="",bty="l")
text(-3.85,1.5,"k=4")
text(-3.85,0.5,"k=3")
text(-3.85,-0.5,"k=2")
text(-3.85,-1.5,"k=1")
text(-3.5,3.8,"Item Response")
text(-3.7,3.5,"Category k")
text(-2.7,1.2,"gamma3")
text(-2.7,0.2,"gamma2")
text(-2.7,-.8,"gamma1")
text(3.0,2.1,"gamma'",srt=90,crt=90)
dev.off()
dos("copy fig8-1.eps lpt1")
