postscript("fig8-3.eps",width=3.5,height=2.5,pointsize=7)
par(mfrow=c(1,1),lab=c(8,3,3))
theta<-seq(-3,3,.1)
p0<-1+theta*0
p1<-pnorm(theta,-2,2)
p2<-pnorm(theta,0,2)
p3<-pnorm(theta,2,2)
p4<-0+theta*0
plot(theta,p1,type="l",xlim=c(-3,3),ylim=c(0,1),xlab="Ability",
  ylab="Probability of BCC",bty="l")
par(new=T)
plot(theta,p2,type="l",xlim=c(-3,3),ylim=c(0,1),xlab="",ylab="",bty="l")
par(new=T)
plot(theta,p3,type="l",xlim=c(-3,3),ylim=c(0,1),xlab="",ylab="",bty="l")
par(new=T)
plot(theta,p4,type="l",xlim=c(-3,3),ylim=c(0,1),xlab="",ylab="",bty="l")
par(new=T)
plot(theta,p0,type="l",xlim=c(-3,3),ylim=c(0,1),xlab="",ylab="",bty="l")
text(-2.8,.95,"P*")
text(-2.73,.92,"0",cex=.7)
text(-2.8,.41,"P*")
text(-2.73,.38,"1",cex=.7)
text(2.8,.86,"P*")
text(2.87,.83,"2",cex=.7)
text(2.8,.58,"P*")
text(2.87,.55,"3",cex=.7)
text(2.8,.05,"P*")
text(2.87,.02,"4",cex=.7)
text(0,.92,"P")
text(.12,.89,"1",cex=.7)
text(0,.67,"P")
text(.12,.64,"2",cex=.7)
text(0,.33,"P")
text(.12,.30,"3",cex=.7)
text(0,.08,"P")
text(.12,.05,"4",cex=.7)
text(0,.98,">",srt=90,crt=90)
text(0,.83,">",srt=90,crt=90)
text(0,.48,">",srt=90,crt=90)
text(0,.14,">",srt=90,crt=90)
text(0,.87,"<",srt=90,crt=90)
text(0,.52,"<",srt=90,crt=90)
text(0,.18,"<",srt=90,crt=90)
text(0,.02,"<",srt=90,crt=90)
text(.01,.97,"-",srt=90,crt=90)
text(.01,.78,"----",srt=90,crt=90)
text(.01,.43,"----",srt=90,crt=90)
text(.01,.13,"-",srt=90,crt=90)
text(.01,.88,"-",srt=90,crt=90)
text(.01,.57,"----",srt=90,crt=90)
text(.01,.23,"----",srt=90,crt=90)
text(.01,.03,"-",srt=90,crt=90)
dev.off()
dos("copy fig8-3.eps lpt1")
