postscript("fig9-1.eps",width=3.5,height=2.5,pointsize=7)
par(mfrow=c(1,1),lab=c(8,3,3))
theta<-seq(-3,3,.1)
z1<--.75+-.20*theta
z2<-.25+-.80*theta
z3<-.50+1.00*theta
p1<-exp(z1)/(exp(z1)+exp(z2)+exp(z3))
p2<-exp(z2)/(exp(z1)+exp(z2)+exp(z3))
p3<-exp(z3)/(exp(z1)+exp(z2)+exp(z3))
plot(theta,p1,type="l",xlim=c(-3,3),ylim=c(0,1),xlab="Ability",
  ylab="Probability of Response Category",bty="l")
par(new=T)
plot(theta,p2,type="l",xlim=c(-3,3),ylim=c(0,1),xlab="",ylab="",bty="l")
par(new=T)
plot(theta,p3,type="l",xlim=c(-3,3),ylim=c(0,1),xlab="",ylab="",bty="l")
text(-2.8,.87,"2")
text(-.2,.21,"1")
text(2.8,.92,"3")
dev.off()
dos("copy fig9-1.eps lpt1")
