postscript("fig9-3.eps",width=3.5,height=2.5,pointsize=7)
par(mfrow=c(1,1),lab=c(8,3,3))
theta<-seq(-3,3,.1)
l1<--.20
l2<--.80
l3<-1.00
z1<--.75+-.20*theta
z2<-.25+-.80*theta
z3<-.50+1.00*theta
p1<-exp(z1)/(exp(z1)+exp(z2)+exp(z3))
p2<-exp(z2)/(exp(z1)+exp(z2)+exp(z3))
p3<-exp(z3)/(exp(z1)+exp(z2)+exp(z3))
i<-(l1*p1*(1-p1)-l2*p1*p2-l3*p1*p3)*l1+
  (-l1*p2*p1+l2*p2*(1-p2)-l3*p2*p3)*l2+
  (-l1*p3*p1-l2*p3*p2+l3*p3*(1-p3))*l3
p4<-1/(1+exp(-1.6*(theta-.065)))
id<-1.6*1.6*p4*(1-p4)
plot(theta,i,type="l",xlim=c(-3,3),ylim=c(0,1),xlab="Ability",
  ylab="Item Information",bty="l")
par(new=T)
plot(theta,id,type="l",xlim=c(-3,3),ylim=c(0,1),xlab="",ylab="",bty="l")
text(.0,.78,"Nominal")
text(-.5,.20,"Dichotomous")
dev.off()
dos("copy fig9-3.eps lpt1")
